package examples.junit;

import de.uni_luebeck.isp.rvtool.junitrv.Monitor;
import de.uni_luebeck.isp.rvtool.junitrv.RVRunner;
import de.uni_luebeck.isp.rvtool.javamonitorinjection.api.syntax.Event;
import static de.uni_luebeck.isp.rvtool.javamonitorinjection.api.syntax.DataSyntax.*;
import de.uni_luebeck.isp.rvtool.junitrv.DFLTL4Monitor;
import de.uni_luebeck.isp.rvtool.junitrv.Monitors;
import de.uni_luebeck.isp.rvtool.rvlib.syntax.smt.SMTExpr;
import org.junit.Test;
import org.junit.runner.RunWith;

@SuppressWarnings("serial")
@RunWith(RVRunner.class)
public class SMTTest1_1 {

    private static final String name = "examples/junit/SMTExample1";
    private static final Event doSomething = called(name, "doSomething");
    private static final Predicate predicate1 = new WITH(doSomething) {
        public SMTExpr<Void> p(SMTExample1 exmpl, Integer i) {
            return EQ(INT("x"), i);
        }
    };
    private static final Predicate predicate2 = new WITH(doSomething) {
        public SMTExpr<Void> p(SMTExample1 exmpl, Integer i) {
            return EQ(INT("x"), i - 1);
        }
    };
    private static final Monitor doesSomething = new DFLTL4Monitor(
            G(implies(predicate1, WX(predicate2))),
            "eq", doSomething);

    @Test
    @Monitors("doesSomething")
    public void test1() {
        SMTExample1 example = new SMTExample1();
        long time = System.currentTimeMillis();
        for (int i = 1; i < 10000; ++i) {
            example.doSomething(i);
            if ((i + 1) % 500 == 0) {
                System.out.println("(" + (System.currentTimeMillis() - time) + ", " + (i + 1) + ")");
            }
        }
    }

    @Test
    @Monitors("doesSomething")
    public void test2() {
        SMTExample1 example = new SMTExample1();
        long time = System.currentTimeMillis();
        for (int i = 1; i < 10000; ++i) {
            example.doSomething(i);
            if ((i + 1) % 500 == 0) {
                System.out.println("(" + (i + 1) + ", " + (System.currentTimeMillis() - time) + ")");
            }
        }
    }
}
