package examples.junit;

import de.uni_luebeck.isp.rvtool.junitrv.Monitor;
import de.uni_luebeck.isp.rvtool.junitrv.RVRunner;
import de.uni_luebeck.isp.rvtool.javamonitorinjection.api.syntax.Event;
import de.uni_luebeck.isp.rvtool.junitrv.DFLTL4Monitor;
import de.uni_luebeck.isp.rvtool.junitrv.Monitors;
import org.junit.Test;
import org.junit.runner.RunWith;

import static de.uni_luebeck.isp.rvtool.javamonitorinjection.api.syntax.DataSyntax.*;

@SuppressWarnings("serial")
@RunWith(RVRunner.class)
public class SMTTest1_2 {

    private static final String name = "examples/junit/SMTExample1";
    private static final Event doSomething = called(name, "doSomething");
    private static final INT int1 = new INT() {
        public Integer p(SMTExample1 exmpl, Integer i) {
            return i;
        }
    };
    private static final INT int2 = new INT() {
        public Integer p(SMTExample1 exmpl, Integer i) {
            return i - 1;
        }
    };
    private static final Monitor doesSomething = new DFLTL4Monitor(
            G(implies(EQ(INT("x"), int1), WX(EQ(INT("x"), int2)))),
            "eq", doSomething);

    @Test
    @Monitors("doesSomething")
    public void test1() {
        SMTExample1 example = new SMTExample1();
        long time = System.currentTimeMillis();
        for (int i = 1; i < 10000; ++i) {
            example.doSomething(i);
            if ((i + 1) % 500 == 0) {
                System.out.println("(" + (System.currentTimeMillis() - time) + ", " + (i + 1) + ")");
            }
        }
    }

    @Test
    @Monitors("doesSomething")
    public void test2() {
        SMTExample1 example = new SMTExample1();
        long time = System.currentTimeMillis();
        for (int i = 1; i < 10000; ++i) {
            example.doSomething(i);
            if ((i + 1) % 500 == 0) {
                System.out.println("(" + (i + 1) + ", " + (System.currentTimeMillis() - time) + ")");
            }
        }
    }
}
