package examples.junit;

import de.uni_luebeck.isp.rvtool.junitrv.Monitor;
import de.uni_luebeck.isp.rvtool.junitrv.RVRunner;
import de.uni_luebeck.isp.rvtool.javamonitorinjection.api.syntax.Event;
import de.uni_luebeck.isp.rvtool.junitrv.DFLTL4Monitor;
import de.uni_luebeck.isp.rvtool.junitrv.Monitors;
import de.uni_luebeck.isp.rvtool.rvlib.syntax.smt.SMTExpr;
import org.junit.Test;
import org.junit.runner.RunWith;

import static de.uni_luebeck.isp.rvtool.javamonitorinjection.api.syntax.DataSyntax.*;

@SuppressWarnings("serial")
@RunWith(RVRunner.class)
public class SMTTest2 {

    private static final String name = "examples/junit/SMTExample2";
    private static final Event doSomething = called(name, "doSomething");
    private static final Event doSomethingElse = called(name, "doSomethingElse");
    private static final Event lock = returned(name, "lock");
    private static final Event unlock = called(name, "unlock");
    private static final Predicate lockId = new WITH(lock) {
        public SMTExpr<Void> p(SMTExample2 exmpl, Integer i, Boolean b) {
            return EQ(INT("x"), exmpl.getLock());
        }
    };
    private static final Predicate unlockId = new WITH(unlock) {
        public SMTExpr<Void> p(SMTExample2 exmpl) {
            return EQ(INT("x"), exmpl.getLock());
        }
    };
    private static final Predicate doId = new WHEN(doSomething) {
        public SMTExpr<Void> p(SMTExample2 exmpl, Integer i) {
            return EQ(INT("x"), i);
        }
    };
    private static final Monitor doesSomething = new DFLTL4Monitor(
            G(implies(lockId, X(U(doId, unlockId)))), "z3");

    @Test
    @Monitors("doesSomething")
    public void test1() {
        SMTExample2 example = new SMTExample2();
        example.run(10000, 5);
    }

    @Test
    @Monitors("doesSomething")
    public void test2() {
        SMTExample2 example = new SMTExample2();
        example.run(10000, 5);
    }
}
