package examples.junit;

import de.uni_luebeck.isp.rvtool.junitrv.Monitor;
import de.uni_luebeck.isp.rvtool.junitrv.RVRunner;
import de.uni_luebeck.isp.rvtool.javamonitorinjection.api.syntax.Event;
import de.uni_luebeck.isp.rvtool.junitrv.DFLTL4Monitor;
import de.uni_luebeck.isp.rvtool.junitrv.Monitors;
import de.uni_luebeck.isp.rvtool.rvlib.syntax.smt.SMTExpr;
import org.junit.Test;
import org.junit.runner.RunWith;

import static de.uni_luebeck.isp.rvtool.javamonitorinjection.api.syntax.DataSyntax.*;

@SuppressWarnings({"serial"})
@RunWith(RVRunner.class)
public class SMTTest3_1 {

    private static final String name = "examples/junit/SMTExample3";
    private static final Event open = called(name, "open");
    private static final Event close = called(name, "close");
    private static final Predicate idOpen = new WITH(open) {
        public SMTExpr<Void> p(SMTExample3 exmpl, Integer i) {
            return EQ(INT("x"), i);
        }
    };
    private static final Predicate idClose = new WITH(close) {
        public SMTExpr<Void> p(SMTExample3 exmpl, Integer i) {
            return EQ(INT("x"), i);
        }
    };
    private static final Monitor doesSomething = new DFLTL4Monitor(
            G(implies(idOpen, X(F(idClose)))), "eq");

    @Test
    @Monitors("doesSomething")
    public void test1() {
        SMTExample3 example = new SMTExample3();
        example.run(10000, 50);
    }

    @Test
    @Monitors("doesSomething")
    public void test2() {
        SMTExample3 example = new SMTExample3();
        example.run(10000, 50);
    }
}
