package examples.junit;

import de.uni_luebeck.isp.rvtool.junitrv.Monitor;
import de.uni_luebeck.isp.rvtool.junitrv.RVRunner;
import de.uni_luebeck.isp.rvtool.javamonitorinjection.api.syntax.Event;
import de.uni_luebeck.isp.rvtool.junitrv.DFLTL4Monitor;
import de.uni_luebeck.isp.rvtool.junitrv.Monitors;
import de.uni_luebeck.isp.rvtool.rvlib.syntax.smt.SMTExpr;
import java.util.Iterator;
import org.junit.Test;
import org.junit.runner.RunWith;

import static de.uni_luebeck.isp.rvtool.javamonitorinjection.api.syntax.DataSyntax.*;

@SuppressWarnings("serial")
@RunWith(RVRunner.class)
public class SMTTest4 {

    private static final String name = "examples/junit/SMTExample4";
    private static final Event hasNext = calling(name, "run", "java.util.Iterator", "hasNext");
    private static final Event next = calling(name, "run", "java.util.Iterator", "next");
    private static final Predicate idNext = new WITH(next) {
        public SMTExpr<Void> p(Iterator<?> exmpl) {
            return EQ(ID("x"), OBJ(exmpl));
        }
    };
    private static final Predicate idHasNext = new WITH(hasNext) {
        public SMTExpr<Void> p(Iterator<?> exmpl) {
            return EQ(ID("x"), OBJ(exmpl));
        }
    };
    private static final Monitor doesSomething = new DFLTL4Monitor(and(
            G(implies(idNext, WX(R(idHasNext, not(idNext))))),
            R(idHasNext, not(idNext))), "z3");

    @Test
    @Monitors("doesSomething")
    public void test1() {
        SMTExample4 example = new SMTExample4();
        example.run(10000, 2);
    }

    @Test
    @Monitors("doesSomething")
    public void test2() {
        SMTExample4 example = new SMTExample4();
        example.run(10000, 2);
    }
}
