package examples.junit;

import de.uni_luebeck.isp.rvtool.junitrv.Monitor;
import de.uni_luebeck.isp.rvtool.junitrv.RVRunner;
import de.uni_luebeck.isp.rvtool.javamonitorinjection.api.syntax.Event;
import de.uni_luebeck.isp.rvtool.junitrv.Monitors;
import java.util.Iterator;
import org.junit.Test;
import org.junit.runner.RunWith;

import static de.uni_luebeck.isp.rvtool.javamonitorinjection.api.syntax.DataSyntax.*;
import de.uni_luebeck.isp.rvtool.javamonitorinjection.api.syntax.Property;
import de.uni_luebeck.isp.rvtool.rvlib.syntax.smt.SMTBoolExpr;
import de.uni_luebeck.isp.rvtool.rvlib.syntax.smt.SMTExpr;
import de.uni_luebeck.isp.rvtool.salt.SaltMonitor;

@SuppressWarnings("serial")
@RunWith(RVRunner.class)
public class SMTTest4_4 {

    private static final String name = "examples/junit/SMTExample4";
    private static final Event HAS_NEXT = calling(name, "run2?", "java.util.Iterator", "hasNext");
    private static final Event NEXT = calling(name, "run2?", "java.util.Iterator", "next");
    private static final ID id = new ID() {
        public Object p(Iterator<?> exmpl) {
            return exmpl;
        }
    };
    private static final SMTBoolExpr<Property<SMTExpr<Void>>> IDCNSTR = EQ(ID("x"), id);

    private static final Monitor doesSomething = new SaltMonitor("(not (NEXT and IDCNSTR) until weak (HAS_NEXT and IDCNSTR)) and always ((NEXT and IDCNSTR) implies next weak (not (NEXT and IDCNSTR) until weak (HAS_NEXT and IDCNSTR)))", true);

    @Test
    @Monitors("doesSomething")
    public void test1() {
        SMTExample4 example = new SMTExample4();
        example.run2(10000, 20);
    }

    @Test
    @Monitors("doesSomething")
    public void test2() {
        SMTExample4 example = new SMTExample4();
        example.run2(10000, 20);
    }
}
