package examples.junit;

import de.uni_luebeck.isp.rvtool.junitrv.Monitor;
import de.uni_luebeck.isp.rvtool.junitrv.RVRunner;
import de.uni_luebeck.isp.rvtool.javamonitorinjection.api.syntax.Event;
import de.uni_luebeck.isp.rvtool.junitrv.DFLTL4Monitor;
import de.uni_luebeck.isp.rvtool.junitrv.Monitors;
import de.uni_luebeck.isp.rvtool.rvlib.syntax.smt.SMTBool;
import de.uni_luebeck.isp.rvtool.rvlib.syntax.smt.SMTExpr;
import org.junit.Test;
import org.junit.runner.RunWith;

import static de.uni_luebeck.isp.rvtool.javamonitorinjection.api.syntax.DataSyntax.*;

@SuppressWarnings("serial")
@RunWith(RVRunner.class)
public class SMTTest5 {

    private static final String name = "examples/junit/SMTExample5";
    private static final Event step = called(name, "step");
    private static final Predicate values = new WITH(step) {
        public SMTExpr<Void> p(SMTExample5 exmpl, Double pos, Double time) {
            return AND(EQ(REAL("t"), time), EQ(REAL("s"), pos));
        }
    };
    private static final Predicate limit = new WITH(step) {
        public SMTExpr<Void> p(SMTExample5 exmpl, Double pos, Double time) {
            SMTExpr<Void> lim = LT(ADD(pos, MINUS(REAL("s"))), MUL(10.0, ADD(time, MINUS(REAL("t")))));
            return time == 0.0 ? new SMTBool<Void>(true) : lim;
        }
    };
    private static final Monitor doesSomething = new DFLTL4Monitor(
            G(implies(values, WX(limit))),
            "z3");

    @Test
    @Monitors("doesSomething")
    public void test1() {
        SMTExample5 example = new SMTExample5();
        example.run(10000, 50, 5.0);
    }

    @Test
    @Monitors("doesSomething")
    public void test2() {
        SMTExample5 example = new SMTExample5();
        example.run(10000, 50, 5.0);
    }
}
