package examples.junit;

import de.uni_luebeck.isp.rvtool.junitrv.Monitor;
import de.uni_luebeck.isp.rvtool.junitrv.RVRunner;
import de.uni_luebeck.isp.rvtool.javamonitorinjection.api.syntax.Event;
import de.uni_luebeck.isp.rvtool.junitrv.DFLTL4Monitor;
import de.uni_luebeck.isp.rvtool.junitrv.Monitors;
import de.uni_luebeck.isp.rvtool.rvlib.syntax.smt.SMTExpr;
import org.junit.Test;
import org.junit.runner.RunWith;

import static de.uni_luebeck.isp.rvtool.javamonitorinjection.api.syntax.DataSyntax.*;

@SuppressWarnings("serial")
@RunWith(RVRunner.class)
public class SMTTest6 {

    private static final String name = "examples/junit/SMTExample6";
    private static final Event open = called(name, "open");
    private static final Event close = called(name, "close");
    private static final Predicate idOpen = new WITH(open) {
        public SMTExpr<Void> p(SMTExample6 exmpl, Integer i) {
            return EQ(INT("x"), i);
        }
    };
    private static final Predicate idClose = new WITH(close) {
        public SMTExpr<Void> p(SMTExample6 exmpl, Integer i, Integer j) {
            return AND(EQ(INT("x"), i), EQ(INT("y"), j));
        }
    };
    private static final Monitor doesSomething = new DFLTL4Monitor(
            G(implies(idOpen, X(F(EX_INT("y", idClose))))), "z3");

    @Test
    @Monitors("doesSomething")
    public void test1() {
        SMTExample6 example = new SMTExample6();
        example.run(10000, 5, 5);
    }

    @Test
    @Monitors("doesSomething")
    public void test2() {
        SMTExample6 example = new SMTExample6();
        example.run(10000, 5, 5);
    }
}
