package examples.junit;

import de.uni_luebeck.isp.rvtool.javamonitorinjection.api.LTL4Descriptor;
import de.uni_luebeck.isp.rvtool.javamonitorinjection.api.LoggingHandler;
import de.uni_luebeck.isp.rvtool.javamonitorinjection.api.MonitorDescriptor;
import de.uni_luebeck.isp.rvtool.javamonitorinjection.api.MonitorDescriptors;
import de.uni_luebeck.isp.rvtool.javamonitorinjection.api.Monitoring;
import de.uni_luebeck.isp.rvtool.javamonitorinjection.api.syntax.Event;
import de.uni_luebeck.isp.rvtool.javamonitorinjection.api.syntax.Property;
import static de.uni_luebeck.isp.rvtool.javamonitorinjection.api.syntax.SimpleSyntax.*;
import de.uni_luebeck.isp.rvtool.rvlib.syntax.ltl.LTL;
import examples.application.VectorWrapper;
import javassist.Loader;

@SuppressWarnings("serial")
public class Simple {

    private static final String vector = "examples/application/VectorWrapper";
    private static final Event called = called(vector, "get");
    private static final LTL<Property<Boolean>> formula = G(new WHEN(called) {
        public boolean p(VectorWrapper<?> w, Integer i) {
            return w.length() > i;
        }
    });
    @SuppressWarnings("unchecked")
    public static final MonitorDescriptors<? extends MonitorDescriptor<?, ?, ?>> DESCRIPTORS = new MonitorDescriptors<>(
            new MonitorDescriptor<>("monitor1", new LTL4Descriptor(formula), LoggingHandler.GLOBAL, called));

    public static void main(String[] args) throws Throwable {
        Loader loader = Monitoring.getLoader(DESCRIPTORS);
        loader.run("examples.application.SimpleMain", args);
    }
}
